SystemOrganization addCategory: #'Xenon-Examples-Fibonacci'!
SystemOrganization addCategory: #'Xenon-Examples-Factorial'!
SystemOrganization addCategory: #'Xenon-Examples'!

Object subclass: #XeHelloWorld
	uses: XeTSimpleMain + XeTStdio + XeDefineOnCG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Examples'!

!XeHelloWorld commentStamp: 'BernardoContreras 6/22/2012 00:02' prior: 0!
The classic hello world.

!

XeHelloWorld class
	uses: XeTSimpleMain classTrait + XeTStdio classTrait + XeDefineOnCG classTrait
	instanceVariableNames: ''!

!XeHelloWorld class methodsFor: 'translation' stamp: 'BernardoContreras 6/22/2012 21:02'!
defineOn: cg
 	self defineStdioOn: cg! !

!XeHelloWorld methodsFor: 'main' stamp: 'BernardoContreras 6/22/2012 20:20'!
mainEntry
	<returnType: #int>
	self puts: 'Hello World!!'.
	^ 0! !

Object subclass: #XeHelloWorldProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Examples'!

!XeHelloWorldProject commentStamp: '<historical>' prior: 0!
define the hello world project and
export it to the filesystem

usage:
XeHelloWorldProject exportTo: './Hello'!

!XeHelloWorldProject class methodsFor: 'accessing' stamp: 'BernardoContreras 7/7/2012 20:22'!
exportTo: aDirectoryString 
	^ self new exportTo: aDirectoryString ! !

!XeHelloWorldProject methodsFor: 'accessing' stamp: 'BernardoContreras 7/7/2012 20:45'!
exportTo: aDirectoryString 
	| dir make cg filename |
	filename := 'hello.c'.
	dir := aDirectoryString asFileReference ensureDirectory deleteAllChildren.
	make := CMMakeGenerator v2dot6.
	make project add: 'Hello'.
	make addExecutable addAll: {'Hello'. filename}.
	make enableTesting.
	make addTest addAll: {'say_hello'. 'Hello'}.	
	make writeTo: dir / 'CMakeLists.txt'.
	cg := XeCodeGenerator new.
	cg addClass: XeHelloWorld.
	dir / filename writeStreamDo: [:stream | cg translateOn: stream ].
	^ self ! !

Object subclass: #XeImperativeFactorial
	uses: XeTSimpleMain + XeTStdio + XeTAssert + XeDefineOnCG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Examples-Factorial'!

!XeImperativeFactorial commentStamp: '<historical>' prior: 0!
http://en.wikipedia.org/wiki/Factorial
without recursion
!

XeImperativeFactorial class
	uses: XeTStdio classTrait @ {#defineStdioOn:->#defineOn:} + XeTSimpleMain classTrait + XeTAssert classTrait @ {#defineAssertOn:->#defineOn:} + XeDefineOnCG classTrait
	instanceVariableNames: ''!

!XeImperativeFactorial class methodsFor: 'translation' stamp: 'BernardoContreras 6/22/2012 21:01'!
defineOn: cg
	self defineAssertOn: cg.
	self defineStdioOn: cg! !

!XeImperativeFactorial methodsFor: 'c code' stamp: 'BernardoContreras 6/13/2012 00:32'!
factorial: x
	<returnType: #int>
	<var: #x type: #int>
	<var: #result type: #int>
	<var: #i type: #int>
	| result i |
	result := 1.
	i := 1.
	[ i <= x ]
		whileTrue: [ 
			result := result * i.
			i := i + 1 ].
	^ result! !

!XeImperativeFactorial methodsFor: 'main' stamp: 'BernardoContreras 6/22/2012 21:03'!
mainEntry
	<returnType: #int>
	self puts: 'Imperative Factorial'.
	self assert: 3628800 = (self factorial: 10).
	^ 0! !

Object subclass: #XeImperativeFibonacci
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Examples-Fibonacci'!

!XeImperativeFibonacci commentStamp: '<historical>' prior: 0!
http://en.wikipedia.org/wiki/Fibonacci_number
without recursion
!

!XeImperativeFibonacci methodsFor: 'c code' stamp: 'BernardoContreras 6/13/2012 20:56'!
fib: n
	<returnType: #int>
	<var: #n type: #int>
	<var: #fibOne type: #int>
	<var: #fibTwo type: #int>
	<var: #result type: #int>
	<var: #i type: #int>
	
	| i fibOne fibTwo result |
	i := 2.
	fibOne := 0.
	fibTwo := 1.
	n =  0
		ifTrue: [ ^ fibOne ].
	n =  1
		ifTrue: [ ^ fibTwo ].
	[ i <= n ]
		 whileTrue: [  
			result := fibOne + fibTwo.
			fibOne := fibTwo.
			fibTwo := result.
			i  :=  i + 1.
				 ].
	^ result.! !

Object subclass: #XeRecursiveFactorial
	uses: XeTSimpleMain + XeTStdio + XeTAssert + XeDefineOnCG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Examples-Factorial'!

!XeRecursiveFactorial commentStamp: '<historical>' prior: 0!
http://en.wikipedia.org/wiki/Factorial
with recursion
!

XeRecursiveFactorial class
	uses: XeTSimpleMain classTrait + XeTAssert classTrait + XeDefineOnCG classTrait + XeTStdio classTrait
	instanceVariableNames: ''!

!XeRecursiveFactorial class methodsFor: 'translation' stamp: 'BernardoContreras 6/22/2012 21:08'!
defineOn: cg
	self defineAssertOn: cg.
	self defineStdioOn: cg.! !

!XeRecursiveFactorial methodsFor: 'c code' stamp: 'BernardoContreras 6/10/2012 00:14'!
factorial: x
	<returnType: #int>
	<var: #x type: #int>
	x = 0
		ifTrue: [ ^ 1 ]
		ifFalse: [ ^ x * (self factorial: x - 1) ]! !

!XeRecursiveFactorial methodsFor: 'main' stamp: 'BernardoContreras 6/22/2012 21:07'!
mainEntry
	<returnType: #int>
	self puts: 'Recursive Factorial'.
	self assert: 3628800 = (self factorial: 10).
	^ 0! !

Object subclass: #XeRecursiveFibonacci
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Examples-Fibonacci'!

!XeRecursiveFibonacci commentStamp: '<historical>' prior: 0!
http://en.wikipedia.org/wiki/Fibonacci_number
with recursion
!

!XeRecursiveFibonacci methodsFor: 'c code' stamp: 'BernardoContreras 6/10/2012 00:37'!
fib: x
	<returnType: #int>
	<var: #x type: #int>
	x = 0
		ifTrue: [ ^ 1 ].
	x = 1
		ifTrue: [ ^ 1 ].
	^ (self fib: x - 1) + (self fib: x - 2)! !
